searchNodes=[{"ref":"ElasticsearchElixirBulkProcessor.html","title":"ElasticsearchElixirBulkProcessor","type":"module","doc":"Elasticsearch Elixir Bulk Processor is a configurable manager for efficiently inserting data into Elasticsearch. This processor uses genstages for handling backpressure, and various settings to control the bulk payloads being uploaded to Elasticsearch. Inspired by the Java Bulk Processor Configuration Elasticsearch endpoint Can be configurate via the ELASTICSEARCH_URL environment variable, defaults to: &quot;http://localhost:9200&quot;. Action count Number of actions/items to send per bulk (can be changed at run time) ElasticsearchElixirBulkProcessor.set_event_count_threshold(100) Byte size Max number of bytes to send per bulk (can be changed at run time) ElasticsearchElixirBulkProcessor.set_byte_threshold(100) Action order Preservation of order of actions/items config :elasticsearch_elixir_bulk_processor, preserve_event_order: false Retries Retry policy, this uses the ElixirRetry DSL. See ElasticsearchElixirBulkProcessor.Bulk.Retry.policy. config :elasticsearch_elixir_bulk_processor, retry_function: &amp;MyApp.Retry.policy/0 Success and error handlers The callbacks on a successful upload or in case of failed items or failed request can bet set through the config. On success, the handler is called with the Elasticsearch bulk request. On failure, the hanlder is called with%{data: any, error: any}, data being the original payload and error being the response or HTTP error. See ElasticsearchElixirBulkProcessor.Bulk.Handlers. config :elasticsearch_elixir_bulk_processor, success_function: &amp;MyApp.success_handler/1, error_function: &amp;MyApp.error_handler/1"},{"ref":"ElasticsearchElixirBulkProcessor.html#send_requests/1","title":"ElasticsearchElixirBulkProcessor.send_requests/1","type":"function","doc":"Send a list of request items to ELasticsearch. This mechanism uses GenStages for back pressure. NOTE: It should be completely reasonable to use this function by passing single element lists, the mechanism aggregates the items together prior to sending them. The list elements must be structs: ElasticsearchElixirBulkProcessor.Items.Index ElasticsearchElixirBulkProcessor.Items.Create ElasticsearchElixirBulkProcessor.Items.Update ElasticsearchElixirBulkProcessor.Items.Delete Examples iex&gt; alias ElasticsearchElixirBulkProcessor.Items.Index ...&gt; [ ...&gt; %Index{index: &quot;test_index&quot;, source: %{&quot;field&quot; =&gt; &quot;value1&quot;}}, ...&gt; %Index{index: &quot;test_index&quot;, source: %{&quot;field&quot; =&gt; &quot;value2&quot;}}, ...&gt; %Index{index: &quot;test_index&quot;, source: %{&quot;field&quot; =&gt; &quot;value3&quot;}} ...&gt; ] ...&gt; |&gt; ElasticsearchElixirBulkProcessor.send_requests() :ok"},{"ref":"ElasticsearchElixirBulkProcessor.html#set_byte_threshold/1","title":"ElasticsearchElixirBulkProcessor.set_byte_threshold/1","type":"function","doc":"Set the maximum number of bytes to send to elasticsearch per bulk request. Examples iex&gt; ElasticsearchElixirBulkProcessor.set_byte_threshold(10) :ok"},{"ref":"ElasticsearchElixirBulkProcessor.html#set_event_count_threshold/1","title":"ElasticsearchElixirBulkProcessor.set_event_count_threshold/1","type":"function","doc":"Set the maximum count of items to send to elasticsearch per bulk request. Examples iex&gt; ElasticsearchElixirBulkProcessor.set_byte_threshold(10) :ok"},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage.html","title":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage.html#handle_cast/2","title":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage.handle_cast/2","type":"function","doc":"Invoked to handle asynchronous cast/2 messages. request is the request message sent by a cast/2 and state is the current state of the GenStage. Returning {:noreply, [event], new_state} dispatches the events and continues the loop with new state new_state. Returning {:noreply, [event], new_state, :hibernate} is similar to {:noreply, new_state} except the process is hibernated before continuing the loop. See the return values for GenServer.handle_call/3 for more information on hibernation. Returning {:stop, reason, new_state} stops the loop and terminate/2 is called with the reason reason and state new_state. The process exits with reason reason. If this callback is not implemented, the default implementation by use GenStage will return {:stop, {:bad_cast, request}, state}. Callback implementation for GenStage.handle_cast/2."},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage.html#handle_events/3","title":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage.handle_events/3","type":"function","doc":"Invoked on :producer_consumer and :consumer stages to handle events. Must always be explicitly implemented by such types. Return values are the same as c:handle_cast/2. Callback implementation for GenStage.handle_events/3."},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage.html#init/1","title":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 (or start/3) will block until this callback returns. args is the argument term (second argument) passed to start_link/3 (or start/3). In case of successful start, this callback must return a tuple where the first element is the stage type, which is one of: :producer :consumer :producer_consumer (if the stage is acting as both) For example: def init(args) do {:producer, some_state} end The returned tuple may also contain 3 or 4 elements. The third element may be the :hibernate atom or a set of options defined below. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling terminate/2. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling terminate/2. Options This callback may return options. Some options are specific to the chosen stage type while others are shared across all types. :producer options :demand - when :forward, the demand is always forwarded to the c:handle_demand/2 callback. When :accumulate, demand is accumulated until its mode is set to :forward via demand/2. This is useful as a synchronization mechanism, where the demand is accumulated until all consumers are subscribed. Defaults to :forward. :producer and :producer_consumer options :buffer_size - the size of the buffer to store events without demand. Can be :infinity to signal no limit on the buffer size. Check the &quot;Buffer events&quot; section of the module documentation. Defaults to 10_000 for :producer, :infinity for :producer_consumer. :buffer_keep - returns whether the :first or :last entries should be kept on the buffer in case the buffer size is exceeded. Defaults to :last. :dispatcher - the dispatcher responsible for handling demands. Defaults to GenStage.DemandDispatch. May be either an atom representing a dispatcher module or a two-element tuple with the dispatcher module and the dispatcher options. :consumer and :producer_consumer options :subscribe_to - a list of producers to subscribe to. Each element represents either the producer module or a tuple with the producer module and the subscription options (as defined in sync_subscribe/2). Callback implementation for GenStage.init/1."},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage.html#set_byte_threshold/1","title":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage.set_byte_threshold/1","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage.html#set_event_count_threshold/1","title":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage.set_event_count_threshold/1","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage.html#set_preserve_event_order/1","title":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage.set_preserve_event_order/1","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage.html#start_link/1","title":"ElasticsearchElixirBulkProcessor.Bulk.BulkStage.start_link/1","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.Client.html","title":"ElasticsearchElixirBulkProcessor.Bulk.Client","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.Client.html#bulk_upload/3","title":"ElasticsearchElixirBulkProcessor.Bulk.Client.bulk_upload/3","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.Client.html#convert_multiple_to_error/1","title":"ElasticsearchElixirBulkProcessor.Bulk.Client.convert_multiple_to_error/1","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.DirectUpload.html","title":"ElasticsearchElixirBulkProcessor.Bulk.DirectUpload","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.DirectUpload.html#add_requests/1","title":"ElasticsearchElixirBulkProcessor.Bulk.DirectUpload.add_requests/1","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.Handlers.html","title":"ElasticsearchElixirBulkProcessor.Bulk.Handlers","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.Handlers.html#default_error/1","title":"ElasticsearchElixirBulkProcessor.Bulk.Handlers.default_error/1","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.Handlers.html#default_success/1","title":"ElasticsearchElixirBulkProcessor.Bulk.Handlers.default_success/1","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.Payload.html","title":"ElasticsearchElixirBulkProcessor.Bulk.Payload","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.Payload.html#manage_payload/3","title":"ElasticsearchElixirBulkProcessor.Bulk.Payload.manage_payload/3","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.Payload.html#send/2","title":"ElasticsearchElixirBulkProcessor.Bulk.Payload.send/2","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.Payload.html#send_payload/3","title":"ElasticsearchElixirBulkProcessor.Bulk.Payload.send_payload/3","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.QueueStage.html","title":"ElasticsearchElixirBulkProcessor.Bulk.QueueStage","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.QueueStage.html#add/1","title":"ElasticsearchElixirBulkProcessor.Bulk.QueueStage.add/1","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.QueueStage.html#handle_cast/2","title":"ElasticsearchElixirBulkProcessor.Bulk.QueueStage.handle_cast/2","type":"function","doc":"Invoked to handle asynchronous cast/2 messages. request is the request message sent by a cast/2 and state is the current state of the GenStage. Returning {:noreply, [event], new_state} dispatches the events and continues the loop with new state new_state. Returning {:noreply, [event], new_state, :hibernate} is similar to {:noreply, new_state} except the process is hibernated before continuing the loop. See the return values for GenServer.handle_call/3 for more information on hibernation. Returning {:stop, reason, new_state} stops the loop and terminate/2 is called with the reason reason and state new_state. The process exits with reason reason. If this callback is not implemented, the default implementation by use GenStage will return {:stop, {:bad_cast, request}, state}. Callback implementation for GenStage.handle_cast/2."},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.QueueStage.html#handle_demand/2","title":"ElasticsearchElixirBulkProcessor.Bulk.QueueStage.handle_demand/2","type":"function","doc":"Invoked on :producer stages. This callback is invoked on :producer stages with the demand from consumers/dispatcher. The producer that implements this callback must either store the demand, or return the amount of requested events. Must always be explicitly implemented by :producer stages. Examples def handle_demand(demand, state) do # We check if we&#39;re able to satisfy the demand and fetch # events if we aren&#39;t. events = if length(state.events) &gt;= demand do state.events else # fetch_events() end # We dispatch only the requested number of events. {to_dispatch, remaining} = Enum.split(events, demand) {:noreply, to_dispatch, %{state | events: remaining}} end Callback implementation for GenStage.handle_demand/2."},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.QueueStage.html#init/1","title":"ElasticsearchElixirBulkProcessor.Bulk.QueueStage.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 (or start/3) will block until this callback returns. args is the argument term (second argument) passed to start_link/3 (or start/3). In case of successful start, this callback must return a tuple where the first element is the stage type, which is one of: :producer :consumer :producer_consumer (if the stage is acting as both) For example: def init(args) do {:producer, some_state} end The returned tuple may also contain 3 or 4 elements. The third element may be the :hibernate atom or a set of options defined below. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling terminate/2. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling terminate/2. Options This callback may return options. Some options are specific to the chosen stage type while others are shared across all types. :producer options :demand - when :forward, the demand is always forwarded to the c:handle_demand/2 callback. When :accumulate, demand is accumulated until its mode is set to :forward via demand/2. This is useful as a synchronization mechanism, where the demand is accumulated until all consumers are subscribed. Defaults to :forward. :producer and :producer_consumer options :buffer_size - the size of the buffer to store events without demand. Can be :infinity to signal no limit on the buffer size. Check the &quot;Buffer events&quot; section of the module documentation. Defaults to 10_000 for :producer, :infinity for :producer_consumer. :buffer_keep - returns whether the :first or :last entries should be kept on the buffer in case the buffer size is exceeded. Defaults to :last. :dispatcher - the dispatcher responsible for handling demands. Defaults to GenStage.DemandDispatch. May be either an atom representing a dispatcher module or a two-element tuple with the dispatcher module and the dispatcher options. :consumer and :producer_consumer options :subscribe_to - a list of producers to subscribe to. Each element represents either the producer module or a tuple with the producer module and the subscription options (as defined in sync_subscribe/2). Callback implementation for GenStage.init/1."},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.QueueStage.html#start_link/1","title":"ElasticsearchElixirBulkProcessor.Bulk.QueueStage.start_link/1","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.Retry.html","title":"ElasticsearchElixirBulkProcessor.Bulk.Retry","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.Retry.html#default/0","title":"ElasticsearchElixirBulkProcessor.Bulk.Retry.default/0","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.Retry.html#policy/0","title":"ElasticsearchElixirBulkProcessor.Bulk.Retry.policy/0","type":"function","doc":"Reads the application variable retry_function and uses as the result as the retyr policy. ElixirRetry is used for retrying. The default policy is: constant_backoff(100) |&gt; Stream.take(5) Examples iex&gt; use Retry ...&gt; Application.put_env(:elasticsearch_elixir_bulk_processor, :retry_function, fn -&gt; ...&gt; constant_backoff(100) |&gt; Stream.take(2) ...&gt; end) ...&gt; ElasticsearchElixirBulkProcessor.Bulk.Retry.policy() |&gt; Enum.to_list() &#39;dd&#39; iex&gt; use Retry ...&gt; Application.put_env(:elasticsearch_elixir_bulk_processor, :retry_function, nil) ...&gt; ElasticsearchElixirBulkProcessor.Bulk.Retry.policy() |&gt; Enum.to_list() &#39;ddddd&#39;"},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.Upload.html","title":"ElasticsearchElixirBulkProcessor.Bulk.Upload","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Bulk.Upload.html#add_requests/1","title":"ElasticsearchElixirBulkProcessor.Bulk.Upload.add_requests/1","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.ElasticsearchCluster.html","title":"ElasticsearchElixirBulkProcessor.ElasticsearchCluster","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.ElasticsearchCluster.html#child_spec/1","title":"ElasticsearchElixirBulkProcessor.ElasticsearchCluster.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ElasticsearchElixirBulkProcessor.ElasticsearchCluster.html#start_link/1","title":"ElasticsearchElixirBulkProcessor.ElasticsearchCluster.start_link/1","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Helpers.BulkResponse.html","title":"ElasticsearchElixirBulkProcessor.Helpers.BulkResponse","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Helpers.BulkResponse.html#all_items_error?/1","title":"ElasticsearchElixirBulkProcessor.Helpers.BulkResponse.all_items_error?/1","type":"function","doc":"Given a list of items return true if all have an error. Examples iex&gt; items = [%{&quot;index&quot; =&gt; %{&quot;error&quot; =&gt; %{}}}, %{&quot;update&quot; =&gt; %{&quot;error&quot; =&gt; %{}}}, %{&quot;create&quot; =&gt; %{&quot;error&quot; =&gt; %{}}}, %{&quot;delete&quot; =&gt; %{&quot;error&quot; =&gt; %{}}}] ...&gt; ElasticsearchElixirBulkProcessor.Helpers.BulkResponse.all_items_error?(items) true iex&gt; items = [%{&quot;index&quot; =&gt; %{}}, %{&quot;update&quot; =&gt; %{&quot;error&quot; =&gt; %{}}}, %{&quot;create&quot; =&gt; %{}}, %{&quot;delete&quot; =&gt; %{}}] ...&gt; ElasticsearchElixirBulkProcessor.Helpers.BulkResponse.all_items_error?(items) false"},{"ref":"ElasticsearchElixirBulkProcessor.Helpers.BulkResponse.html#gather_error_items/2","title":"ElasticsearchElixirBulkProcessor.Helpers.BulkResponse.gather_error_items/2","type":"function","doc":"Given a list of items from a bulk response and the data sent as a string payload return the items that match the error. Examples iex&gt; items = [%{&quot;index&quot; =&gt; %{}}, %{&quot;update&quot; =&gt; %{&quot;error&quot; =&gt; %{}}}, %{&quot;create&quot; =&gt; %{}}, %{&quot;delete&quot; =&gt; %{}}] ...&gt; data = &quot;item\\nitem_with_errors\\nitem\\nitem&quot; ...&gt; ElasticsearchElixirBulkProcessor.Helpers.BulkResponse.gather_error_items(items, data) &quot;item_with_errors&quot; iex&gt; items = [%{&quot;index&quot; =&gt; %{&quot;error&quot; =&gt; %{}}}, %{&quot;update&quot; =&gt; %{&quot;error&quot; =&gt; %{}}}, %{&quot;create&quot; =&gt; %{&quot;error&quot; =&gt; %{}}}, %{&quot;delete&quot; =&gt; %{&quot;error&quot; =&gt; %{}}}] ...&gt; data = &quot;item1\\nitem2\\nitem3\\nitem4&quot; ...&gt; ElasticsearchElixirBulkProcessor.Helpers.BulkResponse.gather_error_items(items, data) &quot;item1\\nitem2\\nitem3\\nitem4&quot;"},{"ref":"ElasticsearchElixirBulkProcessor.Helpers.Elasticsearch.html","title":"ElasticsearchElixirBulkProcessor.Helpers.Elasticsearch","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Helpers.Elasticsearch.html#count_current_docs/0","title":"ElasticsearchElixirBulkProcessor.Helpers.Elasticsearch.count_current_docs/0","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Helpers.Elasticsearch.html#delete_index/0","title":"ElasticsearchElixirBulkProcessor.Helpers.Elasticsearch.delete_index/0","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Helpers.Elasticsearch.html#query/1","title":"ElasticsearchElixirBulkProcessor.Helpers.Elasticsearch.query/1","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Helpers.Elasticsearch.html#wait_until_doc_count/3","title":"ElasticsearchElixirBulkProcessor.Helpers.Elasticsearch.wait_until_doc_count/3","type":"function","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Helpers.Events.html","title":"ElasticsearchElixirBulkProcessor.Helpers.Events","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Helpers.Events.html#byte_sum/1","title":"ElasticsearchElixirBulkProcessor.Helpers.Events.byte_sum/1","type":"function","doc":"Return the size of the string in bytes Examples iex&gt; ElasticsearchElixirBulkProcessor.Helpers.Events.byte_sum([&quot;abcd&quot;, &quot;a&quot;, &quot;b&quot;]) 6 iex&gt; ElasticsearchElixirBulkProcessor.Helpers.Events.byte_sum([]) 0"},{"ref":"ElasticsearchElixirBulkProcessor.Helpers.Events.html#chunk_bytes/2","title":"ElasticsearchElixirBulkProcessor.Helpers.Events.chunk_bytes/2","type":"function","doc":"Split list of strings into chunks of given byte size and rest of the list. Examples iex&gt; [&quot;0&quot;, &quot;1&quot;, &quot;2&quot;, &quot;3&quot;, &quot;4&quot;, &quot;5&quot;, &quot;6&quot;, &quot;7&quot;, &quot;8&quot;, &quot;9&quot;] ...&gt; |&gt; ElasticsearchElixirBulkProcessor.Helpers.Events.chunk_bytes(3) [[&quot;0&quot;, &quot;1&quot;, &quot;2&quot;], [&quot;3&quot;, &quot;4&quot;, &quot;5&quot;], [&quot;6&quot;, &quot;7&quot;, &quot;8&quot;], [&quot;9&quot;]] iex&gt; [&quot;00&quot;, &quot;11&quot;, &quot;22&quot;, &quot;33&quot;, &quot;44&quot;] ...&gt; |&gt; ElasticsearchElixirBulkProcessor.Helpers.Events.chunk_bytes(3) [[&quot;00&quot;, &quot;11&quot;], [&quot;22&quot;, &quot;33&quot;], [&quot;44&quot;]]"},{"ref":"ElasticsearchElixirBulkProcessor.Helpers.Events.html#split_first_bytes/2","title":"ElasticsearchElixirBulkProcessor.Helpers.Events.split_first_bytes/2","type":"function","doc":"Split list of strings into first chunk of given byte size and rest of the list. Examples iex&gt; [&quot;0&quot;, &quot;1&quot;, &quot;2&quot;, &quot;3&quot;, &quot;4&quot;, &quot;5&quot;, &quot;6&quot;, &quot;7&quot;, &quot;8&quot;, &quot;9&quot;] ...&gt; |&gt; ElasticsearchElixirBulkProcessor.Helpers.Events.split_first_bytes(3) {[&quot;0&quot;, &quot;1&quot;, &quot;2&quot;], [&quot;3&quot;, &quot;4&quot;, &quot;5&quot;, &quot;6&quot;, &quot;7&quot;, &quot;8&quot;, &quot;9&quot;]} iex&gt; [&quot;00&quot;, &quot;11&quot;, &quot;22&quot;, &quot;33&quot;] ...&gt; |&gt; ElasticsearchElixirBulkProcessor.Helpers.Events.split_first_bytes(3) {[&quot;00&quot;, &quot;11&quot;], [&quot;22&quot;, &quot;33&quot;]} iex&gt; [&quot;0&quot;, &quot;1&quot;, &quot;2&quot;, &quot;3&quot;, &quot;4&quot;, &quot;5&quot;, &quot;6&quot;, &quot;7&quot;, &quot;8&quot;, &quot;9&quot;] ...&gt; |&gt; ElasticsearchElixirBulkProcessor.Helpers.Events.split_first_bytes(0) {[], [&quot;0&quot;, &quot;1&quot;, &quot;2&quot;, &quot;3&quot;, &quot;4&quot;, &quot;5&quot;, &quot;6&quot;, &quot;7&quot;, &quot;8&quot;, &quot;9&quot;]}"},{"ref":"ElasticsearchElixirBulkProcessor.Items.Create.html","title":"ElasticsearchElixirBulkProcessor.Items.Create","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Items.Create.html#to_payload/1","title":"ElasticsearchElixirBulkProcessor.Items.Create.to_payload/1","type":"function","doc":"Examples iex&gt; %ElasticsearchElixirBulkProcessor.Items.Create{index: &quot;test&quot;, source: %{&quot;test&quot; =&gt; &quot;test&quot;}} ...&gt; |&gt; ElasticsearchElixirBulkProcessor.Items.Create.to_payload() &quot;{\\&quot;create\\&quot;:{\\&quot;_index\\&quot;:\\&quot;test\\&quot;}}\\n{\\&quot;test\\&quot;:\\&quot;test\\&quot;}&quot; iex&gt; %ElasticsearchElixirBulkProcessor.Items.Create{index: &quot;test&quot;, id: &quot;1&quot;, source: %{&quot;test&quot; =&gt; &quot;test&quot;}} ...&gt; |&gt; ElasticsearchElixirBulkProcessor.Items.Create.to_payload() &quot;{\\&quot;create\\&quot;:{\\&quot;_index\\&quot;:\\&quot;test\\&quot;,\\&quot;_id\\&quot;:\\&quot;1\\&quot;}}\\n{\\&quot;test\\&quot;:\\&quot;test\\&quot;}&quot;"},{"ref":"ElasticsearchElixirBulkProcessor.Items.Delete.html","title":"ElasticsearchElixirBulkProcessor.Items.Delete","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Items.Delete.html#to_payload/1","title":"ElasticsearchElixirBulkProcessor.Items.Delete.to_payload/1","type":"function","doc":"Examples iex&gt; %ElasticsearchElixirBulkProcessor.Items.Delete{index: &quot;test&quot;, id: &quot;1&quot;} ...&gt; |&gt; ElasticsearchElixirBulkProcessor.Items.Delete.to_payload() &quot;{\\&quot;delete\\&quot;:{\\&quot;_index\\&quot;:\\&quot;test\\&quot;,\\&quot;_id\\&quot;:\\&quot;1\\&quot;}}&quot;"},{"ref":"ElasticsearchElixirBulkProcessor.Items.Index.html","title":"ElasticsearchElixirBulkProcessor.Items.Index","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Items.Index.html#to_payload/1","title":"ElasticsearchElixirBulkProcessor.Items.Index.to_payload/1","type":"function","doc":"Examples iex&gt; %ElasticsearchElixirBulkProcessor.Items.Index{index: &quot;test&quot;, source: %{&quot;test&quot; =&gt; &quot;test&quot;}} ...&gt; |&gt; ElasticsearchElixirBulkProcessor.Items.Index.to_payload() &quot;{\\&quot;index\\&quot;:{\\&quot;_index\\&quot;:\\&quot;test\\&quot;}}\\n{\\&quot;test\\&quot;:\\&quot;test\\&quot;}&quot; iex&gt; %ElasticsearchElixirBulkProcessor.Items.Index{index: &quot;test&quot;, id: &quot;1&quot;, source: %{&quot;test&quot; =&gt; &quot;test&quot;}} ...&gt; |&gt; ElasticsearchElixirBulkProcessor.Items.Index.to_payload() &quot;{\\&quot;index\\&quot;:{\\&quot;_index\\&quot;:\\&quot;test\\&quot;,\\&quot;_id\\&quot;:\\&quot;1\\&quot;}}\\n{\\&quot;test\\&quot;:\\&quot;test\\&quot;}&quot;"},{"ref":"ElasticsearchElixirBulkProcessor.Items.Item.html","title":"ElasticsearchElixirBulkProcessor.Items.Item","type":"behaviour","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Items.Item.html#c:to_payload/1","title":"ElasticsearchElixirBulkProcessor.Items.Item.to_payload/1","type":"callback","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Items.Item.html#t:item/0","title":"ElasticsearchElixirBulkProcessor.Items.Item.item/0","type":"type","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Items.Update.html","title":"ElasticsearchElixirBulkProcessor.Items.Update","type":"module","doc":""},{"ref":"ElasticsearchElixirBulkProcessor.Items.Update.html#to_payload/1","title":"ElasticsearchElixirBulkProcessor.Items.Update.to_payload/1","type":"function","doc":"Examples iex&gt; %ElasticsearchElixirBulkProcessor.Items.Update{index: &quot;test&quot;, id: &quot;1&quot;, retry_on_conflict: 3, return_source: true, source: %{&quot;test&quot; =&gt; &quot;test&quot;}} ...&gt; |&gt; ElasticsearchElixirBulkProcessor.Items.Update.to_payload() &quot;{\\&quot;update\\&quot;:{\\&quot;retry_on_conflict\\&quot;:3,\\&quot;_source\\&quot;:true,\\&quot;_index\\&quot;:\\&quot;test\\&quot;,\\&quot;_id\\&quot;:\\&quot;1\\&quot;}}\\n{\\&quot;test\\&quot;:\\&quot;test\\&quot;}&quot; iex&gt; %ElasticsearchElixirBulkProcessor.Items.Update{index: &quot;test&quot;, id: &quot;1&quot;, source: %{&quot;test&quot; =&gt; &quot;test&quot;}} ...&gt; |&gt; ElasticsearchElixirBulkProcessor.Items.Update.to_payload() &quot;{\\&quot;update\\&quot;:{\\&quot;_index\\&quot;:\\&quot;test\\&quot;,\\&quot;_id\\&quot;:\\&quot;1\\&quot;}}\\n{\\&quot;test\\&quot;:\\&quot;test\\&quot;}&quot;"},{"ref":"Mix.Tasks.InsertTest.html","title":"Mix.Tasks.InsertTest","type":"task","doc":""},{"ref":"Mix.Tasks.InsertTest.html#run/1","title":"Mix.Tasks.InsertTest.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Randomizer.html","title":"Randomizer","type":"module","doc":"Random string generator module."},{"ref":"Randomizer.html#randomizer/2","title":"Randomizer.randomizer/2","type":"function","doc":"Generate random string based on the given legth. It is also possible to generate certain type of randomise string using the options below: :all - generate alphanumeric random string :alpha - generate nom-numeric random string :numeric - generate numeric random string :upcase - generate upper case non-numeric random string :downcase - generate lower case non-numeric random string Example iex&gt; Iurban.String.randomizer(20) //&quot;Je5QaLj982f0Meb0ZBSK&quot;"}]